//"NotaKorB.sci","Nota korygujca - baza danych",12000,0,1.0.1,SYSTEM
//"Dokumenty sprzeday",12400,14,62
//
//"NotaKorB.sci","Nota korygujca - baza danych","\Dokumenty\Sprzeda\",0,1.0.1,SYSTEM

#include "Wydruki - include"
#include "Nagwek i stopka raportu I"

// Dlugosci pol
#define	FL_DATA				10
#define	FL_GUID				36
#define	FL_KOD				40
#define	FLdkNAZWA			40
#define	FLdkOPIS			80
#define	FLdkTYP				4
#define	FLdpOPIS			40
#define	FLkhADRES			80
#define FLkhBKONTO			50
#define	FLkhKODPOCZ			10
#define	FLkhMIEJSCOWOSC		40
#define	FLkhNAZWA			100
#define	FLkhNIP				20
#define FLntOPIS			2000
#define	FLxtNAZWA			99

// Identyfikator rekordu z opisem firmy
#define	BFirmaID			1

// Grupy typow dokumentow sprzedazy ( VAT / bez VAT / inne )
#define	XTrootTYPDK_SPVAT	7002
#define	XTrootTYPDK_SP		7004
#define	XTrootTYPDK_INNE	7008

// Opisy typow dokumentow
#define	XTrootTYPDK_OPIS	8600

// Formy platnosci
#define	XTustaFRM			90

// Notatka
#define	NTtypDK				0
#define BAS_DK				0x10

// Pozycja z kompletu
#define	BFLAGdpDOKOMPL		0x4000

// Przesuniecie Lp dla pozycji ze stawka VAT NP
#define	BEGIN_LP_NP_VAT		10000

//------------------------------------------------------------------------------------------
// rKraj
//------------------------------------------------------------------------------------------

Record rKraj
	String	kod[ FL_KOD + 1 ]
	String	nazwa[ FLxtNAZWA + 1 ]

	Int Sub Init()
		kod = ""
		nazwa = ""
	EndSub

	Int Sub Read( Long argId )
		Int		result

		Init()
		xt.SetKey( "id" )
		xt.SetKeySeg( "id", argId )
		result = xt.GetRec( EQ )
		If !result Then
			kod = xt.GetField( "kod" )
			nazwa = xt.GetField( "nazwa" )
		EndIf
		Read = result
	EndSub
	
	String Sub GetCode()
		GetCode = kod
	EndSub
	
	String Sub GetName()
		GetName = nazwa
	EndSub
	
	Int Sub SetName( String argName )
		nazwa = Mid( argName, 0, FLxtNAZWA )
	EndSub
EndRec

//------------------------------------------------------------------------------------------
// rKontrahent
//		wspolny dla firmy, nabywcy, odbiorcy
//		nazewnictwo skladowych zgodne z nazewnictwem dla firmy !
//------------------------------------------------------------------------------------------
 
Record rKontrahent
	String	nazwa[ FLkhNAZWA + 1 ]
	String	miejscowosc[ FLkhMIEJSCOWOSC + 1 ]
	String	adres[ FLkhADRES + 1 ]
	String	kodPocztowy[ FLkhKODPOCZ + 1 ]
	String	NIP[ FLkhNIP + 1 ]
	rKraj	kraj
	String	dataOd[ FL_DATA + 1 ]
	String	dataDo[ FL_DATA + 1 ]
	
	Int Sub Init()
		nazwa = ""
		miejscowosc = ""
		adres = ""
		kodPocztowy = ""
		NIP = ""
		kraj.Init()
		dataOd = ""
		dataDo = ""
	EndSub

	Int Sub GetObject( Long argId )
		Int		result

		Init()
		kh.SetKey( "id" )
		kh.SetKeySeg( "id", argId )
		result = kh.GetRec( EQ )
		If !result Then
			nazwa = kh.GetField( "nazwa" )
			miejscowosc = kh.GetField( "miejscowosc" )
			adres = BuildAdresFromText( kh.GetField( "ulica" ), kh.GetField( "dom" ), kh.GetField( "lokal" ) )
			kodPocztowy = kh.GetField( "kodpocz" )
			result = kraj.Read( kh.GetField( "idKraju" ) )
			If argId == BFirmaID Then
				NIP = kh.GetField( IIF( kh.GetField( "statusUE" ), "typks", "nazwisko" ) )
			Else
				If kh.GetField( "statusUE" ) Then
					buf = kh.GetField( "nip" )
					While Len( Delete "-" )
					Wend
					NIP = kraj.GetCode() + buf
				Else
					NIP = kh.GetField( "nip" )
				EndIf
			EndIf
			// Brak historii zmian firmy w Symfonii
			dataOd = ""
			dataDo = ""
		EndIf
		GetObject = result
	EndSub
	
	Int Sub LoadSYNTAX( Dispatch argParams )
		// Brak historii zmian firmy w Symfonii
		LoadSYNTAX = 1
	EndSub
EndRec

//------------------------------------------------------------------------------------------
// rNabywcaOdbiorca
//------------------------------------------------------------------------------------------
 
Record rNabywcaOdbiorca
	String	KhNazwa[ FLkhNAZWA + 1 ]
	String	KhMiasto[ FLkhMIEJSCOWOSC + 1 ]
	String	KhAdres[ FLkhADRES + 1 ]
	String	KhPoczta[ FLkhKODPOCZ + 1 ]
	String	KhNip[ FLkhNIP + 1 ]
	rKraj	kraj

	Int Sub Init()
		KhNazwa = ""
		KhMiasto = ""
		KhAdres = ""
		KhPoczta = ""
		KhNip = ""
		kraj.Init()
	EndSub
	
	Int Sub SetContractor( String argName, String argCity, String argAddress, String argPostCode, String argNip, Long argIdKraju )
		KhNazwa = Mid( argName, 0, FLkhNAZWA )
		KhMiasto = Mid( argCity, 0, FLkhMIEJSCOWOSC )
		KhAdres = Mid( argAddress, 0, FLkhADRES )
		KhPoczta = Mid( argPostCode, 0, FLkhKODPOCZ )
		KhNip = Mid( argNip, 0, FLkhNIP )
		kraj.Read( argIdKraju )
	EndSub

EndRec

//------------------------------------------------------------------------------------------
// rDzial
//		brak odpowiednika w Symfonii
//		wypelnianie pustej struktury
//------------------------------------------------------------------------------------------

Record rDzial
	String	kod[ 1 ]
	String	nazwa[ 1 ]
	String	adres[ 1 ]
	String	kodPocztowy[ 1 ]
	String	miejscowosc[ 1 ]
	Int		wydrukSYNTAX
	
	Int Sub Init()
		kod = ""
		nazwa = ""
		adres = ""
		kodPocztowy = ""
		miejscowosc = ""
		wydrukSYNTAX = 0
	EndSub

	Int Sub GetObjByKod()
		Init()
		GetObjByKod = 1
	EndSub
EndRec

//------------------------------------------------------------------------------------------
// rTypDokumentuSp
//------------------------------------------------------------------------------------------

Record rTypDokumentuSp
	String	opis[ FLxtNAZWA + 1 ]
	
	Int Sub Init()
		opis = ""
	EndSub
	
	Int Sub GetObjByKod( String argKod )
		Int	result
		
		Init()
		dk.SetKey( "katalog" )
		dk.SetKeySeg( "katalog", XTrootTYPDK_SPVAT )
		dk.SetKeySeg( "kod", argKod )
		result = dk.GetRec( EQ )
		If result Then
			dk.SetKeySeg( "katalog", XTrootTYPDK_SP )
			dk.SetKeySeg( "kod", argKod )
			result = dk.GetRec( EQ )
		EndIf
		If result Then
			dk.SetKeySeg( "katalog", XTrootTYPDK_INNE )
			dk.SetKeySeg( "kod", argKod )
			result = dk.GetRec( EQ )
		EndIf
		If !result Then
			opis = dk.GetField( "khnazwa" )
		EndIf
		GetObjByKod = result
	EndSub
EndRec

//------------------------------------------------------------------------------------------
// rRejestr
//------------------------------------------------------------------------------------------

Record rRejestr
	Long	id
	String	kod[ FL_KOD + 1 ]
	String	rachunek[ FLkhBKONTO + 1 ]
	Int		typRejestru
	
	Int Sub Init()
		id = 0
		kod = ""
		rachunek = ""
		typRejestru = -1
	EndSub
	
	Int Sub GetObjById( Long argId )
		Int		result

		Init()
		kh.SetKey( "id" )
		kh.SetKeySeg( "id", argId )
		result = kh.GetRec( EQ )
		If !result Then
			id = argId
			kod = kh.GetField( "kod" )
			rachunek = kh.GetField( "bkonto" )
			typRejestru = kh.GetField( "plattypi" )
		EndIf
		GetObjById = result
	EndSub
EndRec

//------------------------------------------------------------------------------------------
// rFormaPlatnosci
//------------------------------------------------------------------------------------------

Record rFormaPlatnosci
	String	nazwa[ FLxtNAZWA + 1 ]
	
	Int Sub Init()
		nazwa = ""
	EndSub

	Int Sub Read( Long argId )
		Int		result

		Init()
		xt.SetKey( "kod" )
		xt.SetKeySeg( "typi", XTustaFRM )
		xt.SetKeySeg( "kod", "" )
		xt.SetKeySeg( "super", 0 )
		result = xt.GetRec( GE )
		While !result && xt.GetKeySeg( "typi" ) == XTustaFRM
			If xt.GetField( "klient" ) == argId Then
				nazwa = xt.GetField( "nazwa" )
				Exit
			EndIf
			result = xt.GetRec( NX )
		Wend
		Read = result
	EndSub
EndRec

//------------------------------------------------------------------------------------------
// rStVAT
//------------------------------------------------------------------------------------------

Record rStVAT
	Int	typ
	
	Int Sub Init()
		typ = -1
	EndSub
	
	Int Sub SetTyp( Int argTyp )
		typ = argTyp
	EndSub
EndRec

//------------------------------------------------------------------------------------------
// rPozycjaPrzedPoKorekcie
//------------------------------------------------------------------------------------------

Record rPozycjaPrzedPoKorekcie
	Long	id
	Int		Lp
	String	opis[ FLdpOPIS + 1 ]
	rStVAT	stVAT
	
	Int Sub Init()
		id = 0
		Lp = 0
		opis = ""
		stVAT.Init()
	EndSub
	
	Long Sub GetIdentifier()
		GetIdentifier = id
	EndSub
	
	Int Sub SetId( Long argId )
		id = argId
	EndSub

	Int Sub SetLp( Int argLp )
		// Lp dla pozycji ze stawka VAT NP bez przesuniecia
		Lp = argLp % BEGIN_LP_NP_VAT
	EndSub

	Int Sub SetOpis( String argOpis )
		opis = Mid( argOpis, 0, FLdpOPIS )
	EndSub
	
	Int Sub SetTypStVat( Int argTypStVAT )
		stVAT.SetTyp( argTypStVAT )
	EndSub
EndRec

//------------------------------------------------------------------------------------------
// rPozycje
//------------------------------------------------------------------------------------------

Record rPozycje
	Long					id
	Int						doKompletu
	rPozycjaPrzedPoKorekcie	PrzedKorekta
	rPozycjaPrzedPoKorekcie	PoKorekcie

	Int Sub Init()
		id = 0
		doKompletu = 0
		PrzedKorekta.Init()
		PoKorekcie.Init()
	EndSub

	Int Sub SetId( Long argId )
		id = argId
	EndSub

	Int Sub SetDoKompletu( Int argDoKompletu )
		doKompletu = argDoKompletu
	EndSub
	
	Int Sub SetPrzedKorekta( Long argId, Int argLp, String argOpis, Int argTypStVAT )
		PrzedKorekta.SetId( argId )
		PrzedKorekta.SetLp( argLp )
		PrzedKorekta.SetOpis( argOpis )
		PrzedKorekta.SetTypStVAT( argTypStVAT )
	EndSub

	Int Sub SetPoKorekcie( Long argId, Int argLp, String argOpis, Int argTypStVAT )
		PoKorekcie.SetId( argId )
		PoKorekcie.SetLp( argLp )
		PoKorekcie.SetOpis( argOpis )
		PoKorekcie.SetTypStVAT( argTypStVAT )
	EndSub
EndRec

//------------------------------------------------------------------------------------------
// rDokumentSp
//------------------------------------------------------------------------------------------

Record rDokumentSp
	Long				id
	String				numer[ FL_KOD + 1 ]
	String				nazwa[ FLdkNAZWA + 1 ]
	String				dataWystawienia[ FL_DATA + 1 ]
	String				dataSprzedazy[ FL_DATA + 1 ]
	String				opis[ FLdkOPIS + 1 ]
	rNabywcaOdbiorca	danekh
	rNabywcaOdbiorca	daneod
	rRejestr			rejestr
	String				terminPlatnosci[ FL_DATA + 1 ]
	String				typDk[ FLdkTYP + 1 ]
	rFormaPlatnosci		formaPl
	String				notatka[ FLntOPIS + 1 ]
	String				guid[ FL_GUID + 1 ]
	Long				IdDokumentuKorygowanego
	rDzial				dzial
	rPozycje			Pozycje( 1 )
	Int					pozycjeCount

	Int Sub Init()
		id = 0
		numer = ""
		nazwa = ""
		dataWystawienia = ""
		dataSprzedazy = ""
		opis = ""
		danekh.Init()
		daneod.Init()
		rejestr.Init()
		terminPlatnosci = ""
		typDk = ""
		formaPl.Init()
		notatka = ""
		guid = ""
		IdDokumentuKorygowanego = 0
		dzial.Init()
		Shrink Pozycje, -1
		Pozycje( 1 ).Init()
		pozycjeCount = 0
	EndSub
	
	String Sub ReadNote( Long argSuper )
		String	result = ""

		nt.SetKey( "super" )
		nt.SetKeySeg( "typi", NTtypDK )
		nt.SetKeySeg( "baza", BAS_DK )
		nt.SetKeySeg( "super", argSuper )
		If !nt.GetRec( EQ ) Then
			result = nt.GetField( "opis" )
		EndIf
		ReadNote = result
	EndSub
	
	Int Sub ReadPositions( Long argSuper )
		Int	ind
		Int	result
	
		dp.SetKey( "super" )
		dp.SetKeySeg( "super", argSuper )
		dp.SetKeySeg( "lp", 0 )
		result = dp.GetRec( GE )
		While !result
			If dp.GetField( "super" ) != argSuper Then
				Exit
			EndIf
			If Pozycje( 1 ).id Then
				Grow Pozycje, 1
			EndIf
			ind = Size( Pozycje )
			Pozycje( ind ).SetId( dp.GetField( "id" ) )
			Pozycje( ind ).SetDoKompletu( dp.GetField( "flag" ) & BFLAGdpDOKOMPL )
			Pozycje( ind ).SetPrzedKorekta( dp.GetField( "idpozkoryg" ), 0, "", -1 )
			Pozycje( ind ).SetPoKorekcie( dp.GetField( "id" ), dp.GetField( "lp" ), dp.GetField( "opis" ), dp.GetField( "stvati" ) )
			result = dp.GetRec( NX )
		Wend
		pozycjeCount = ind
		dp.SetKey( "id" )
		While ind > 0
			dp.SetKeySeg( "id", Pozycje( ind ).PrzedKorekta.GetIdentifier() )
			If !dp.GetRec( EQ ) Then
				Pozycje( ind ).SetPrzedKorekta( dp.GetField( "id" ), dp.GetField( "lp" ), dp.GetField( "opis" ), dp.GetField( "stvati" ) )
			EndIf
			ind = ind - 1
		Wend
	EndSub

	Int Sub GetObjById( Long argId )
		Int		result

		Init()
		dk.SetKey( "id" )
		dk.SetKeySeg( "id", argId )
		result = dk.GetRec( EQ )
		If !result Then
			id = argId
			numer = dk.GetField( "kod" )
			nazwa = dk.GetField( "nazwa" )
			dataWystawienia = dk.GetField( "data" )
			dataSprzedazy = dk.GetField( "datasp" )
			opis = dk.GetField( "opis" )
			danekh.SetContractor( dk.GetField( "khnazwa" ), dk.GetField( "khmiasto" ), dk.GetField( "khadres" ), dk.GetField( "khkodpocz" ), dk.GetField( "khnip" ), dk.GetField( "idKraju" ) )
			daneod.SetContractor( dk.GetField( "odnazwa" ), dk.GetField( "odmiasto" ), dk.GetField( "odadres" ), dk.GetField( "odkodpocz" ), dk.GetField( "khnip" ), dk.GetField( "idKraju" ) )
			rejestr.GetObjById( dk.GetField( "plattypi" ) )
			terminPlatnosci = dk.GetField( "plattermin" )
			typDk = dk.GetField( "typ_dk" )
			formaPl.Read( dk.GetField( "formaplatn" ) )
			notatka = ReadNote( argId )
			guid = dk.GetField( "guid" )
			IdDokumentuKorygowanego = dk.GetField( "iddokkoryg" )
			dzial.GetObjByKod()
			ReadPositions( argId )
		EndIf
		GetObjById = result
	EndSub
EndRec

String sekcjaTypDk

//------------------------------------------------------------------------------------------

// Stawka VAT NP
#define	NULL_VAT	255

rDokumentSp		DokumentKorygowany
rDokumentSp		DokumentPrawidlowy
rDzial			Dzial
rKontrahent		xFirmaPrawidlowy
rKontrahent		xFirmaKorygowany
rRejestr		Rejestr
rTypDokumentuSp	TypDk

xFirmaPrawidlowy.GetObject( BFirmaID )
xFirmaKorygowany.GetObject( BFirmaID )

// argObjectName - dla kompatybilnosci czesci wspolnej raportow z Forte
Int Sub GetTypDokumentuSp( String argObjectName, String argTypDk )
	GetTypDokumentuSp = TypDk.GetObjByKod( argTypDk )
EndSub

// argObjectName i argDepartmentCode - dla kompatybilnosci czesci wspolnej raportow z Forte
Int Sub GetDzial( String argObjectName, String argDepartmentCode )
	GetDzial = Dzial.GetObjByKod()
EndSub

Long Sub GetIdDokumentuKorygowanego( rDokumentSp argDokumentPrawidlowy )
	GetIdDokumentuKorygowanego = argDokumentPrawidlowy.IdDokumentuKorygowanego
EndSub

// argObjectName - dla kompatybilnosci czesci wspolnej raportow z Forte
Int Sub GetPrawidlowyDokumentSp( String argObjectName, Long argId )
	GetPrawidlowyDokumentSp = DokumentPrawidlowy.GetObjById( argId )
EndSub

// argObjectName - dla kompatybilnosci czesci wspolnej raportow z Forte
Int Sub GetKorygowanyDokumentSp( String argObjectName, Long argId )
	GetKorygowanyDokumentSp = DokumentKorygowany.GetObjById( argId )
EndSub

// argObjectName - dla kompatybilnosci czesci wspolnej raportow z Forte
Int Sub GetRejestr( String argObjectName, Long argId )
	GetRejestr = Rejestr.GetObjById( argId )
EndSub

String Sub GetListaKorekt( rDokumentSp argDokumentKorygowany, rDokumentSp argDokumentKorygujacy, String argFieldDB )
	Long	id
	String	result = ""

	dk.SetKey( "id" )
	id = argDokumentKorygowany.id
	While id
		dk.SetKeySeg( "id", id )
		If dk.GetRec( EQ ) Then
			id = 0
		Else
			result = result + dk.GetField( argFieldDB ) + "\n"
			id = dk.GetField( "idkorekt" )
			id = IIF( id != argDokumentKorygujacy.id, id, 0 )
		EndIf
	Wend
	GetListaKorekt = result
EndSub

String Sub GetListaKorektNumer( rDokumentSp argDokumentKorygowany, rDokumentSp argDokumentKorygujacy )
	GetListaKorektNumer = GetListaKorekt( argDokumentKorygowany, argDokumentKorygujacy, "kod" )
EndSub

String Sub GetListaKorektDataWystawienia( rDokumentSp argDokumentKorygowany, rDokumentSp argDokumentKorygujacy )
	GetListaKorektDataWystawienia = GetListaKorekt( argDokumentKorygowany, argDokumentKorygujacy, "data" )
EndSub

String Sub GetListaKorektDataSprzedazy( rDokumentSp argDokumentKorygowany, rDokumentSp argDokumentKorygujacy )
	GetListaKorektDataSprzedazy = GetListaKorekt( argDokumentKorygowany, argDokumentKorygujacy, "dataSp" )
EndSub

Int Sub DokumentPozycjeCount( rDokumentSp argDokument )
	DokumentPozycjeCount = argDokument.pozycjeCount
EndSub

// Synchronizacja skladni czesci wspolnej raportow
#define	Pozycje_item		Pozycje

// Wydruk bez pobierania informacji z repozytorium
#define	ReadFromRepository	0