//"NotaKorU.sci","Nota korygujca - ustawienia wydruku",12000,0,1.0.4,SYSTEM
//"Dokumenty sprzeday",12400,14,62
//
//"NotaKorU.sci","Nota korygujca - ustawienia wydruku","\Dokumenty\Sprzeda\",0,1.0.4,SYSTEM

//######################################################
//#     Raporty WSPOLNE dla linii Forte i Symfonia     #
//######################################################

Limit 32767

// Ukrycie daty wystawienia do czasu modyfikacji edycji noty korygujacej
#define		HIDE_INVOICE_DATE

// Ukrycie nabywcy / sprzedawcy ( okno wyboru bitmapy )
#define		HIDE_CUSTOMER_SALESMAN

// Wyszarzenie przycisku "Przegladaj" ( okno wyboru bitmapy )
#define		DISABLE_LOOKIN

#define	GRAFICZNY			!Val( Arg0 )					// wydruk graficzny / tekstowy
#define	dY					IIF( GRAFICZNY, 40, 0 )			// przesuniecie elementow okna w pionie
#define	NL					( Using "%c%c", 13, 10 )		// przejscie do nowej linii w polu MEDIT
#define	OK			 		2
#define	ANULUJ				-1
#define	STVAT_NIEPODLEGA	NULL_VAT						// typ stawki VAT "nie podlega"

// Klucz pliku INI z liczba wydrukow
#define	KLUCZ_ILOSC_KOPII				"IloscKopii"

// Sekcja pliku INI z zapisywanymi ustawieniami / danymi wydruku
#define	SEKCJA_INI						"Wydruki - Nota korygujaca"

// Max dlugosc tekstu zapisywana do pliku INI
#define	TOKEN_MAX_LEN					250

// Separator opisu i danych w tresci korygowanej i prawidlowej
#define	DELIMITER						"...."

// Objasnienia w oknie "tresc korygowana / tresc prawidlowa"
#define	T_INFO_SPRZEDAWCA				( Using "Sprzedawca %s\t\t", DELIMITER )
#define	T_INFO_ADRES_SPRZEDAWCY			( Using "Adres sprzedawcy %s\t\t", DELIMITER )
#define	T_INFO_NIP_SPRZEDAWCY			( Using "NIP sprzedawcy %s\t\t", DELIMITER )
#define	T_INFO_NABYWCA					( Using "Nabywca %s\t\t", DELIMITER )
#define	T_INFO_ADRES_NABYWCY			( Using "Adres nabywcy %s\t\t", DELIMITER )
#define	T_INFO_NIP_NABYWCY				( Using "NIP nabywcy %s\t\t", DELIMITER )
#define	T_INFO_ODBIORCA					( Using "Odbiorca %s\t\t", DELIMITER )
#define	T_INFO_ADRES_ODBIORCY			( Using "Adres odbiorcy %s\t\t", DELIMITER )
#define	T_INFO_DATA_WYSTAWIENIA			( Using "Data wystawienia %s\t\t", DELIMITER )
#define	T_INFO_DATA_SPRZEDAZY			( Using "Data sprzeday %s\t\t", DELIMITER )
#define	T_INFO_REJESTR_FORMA_PLATNOSCI	( Using "Rejestr / forma patnoci %s\t", DELIMITER )
#define	T_INFO_OPIS_DOKUMENTU			( Using "Opis dokumentu %s\t\t", DELIMITER )
#define	T_INFO_NOTATKA_DOKUMENTU		( Using "Notatka dokumentu %s\t", DELIMITER )
#define	T_INFO_OPISY_POZYCJI			( Using "Opisy pozycji %s\t", DELIMITER )
#define	T_INFO_TAB_DANE					"\t\t\t"
#define	T_INFO_TAB_NR_POZYCJI			"\t\t"

#define	T_INFO_POZYCJE_NP				"---------- Pozycje nie podlegajce VAT ----------"

Dispatch	xParamsFirm

Long		lIdDok = Val( Arg1 )

// Okno "Ustawienia wydruku noty korygujacej"
Int			iNazwaSprzedawcy
Int			iDaneAdresoweSprzedawcy
Int			iNipSprzedawcy
Int			iNazwaNabywcy
Int			iDaneAdresoweNabywcy
Int			iNipNabywcy
Int			iNazwaOdbiorcy
Int			iDaneAdresoweOdbiorcy
Int			iDataWystawienia
Int			iDataSprzedazy
Int			iRejestrFormaPlatnosci
Int			iOpisDokumentu
Int			iNotatkaDokumentu
Int			iZmienioneOpisyPozycji
Int			iDrukujOpisTypuDokumentu

// Liczba wydrukow
Int			IloscKopii

// Okno "Tresc korygowana / Tresc prawidlowa"	( aktualna z ew. zmianami uzytkownika )
String		sTrescKorygowana
String		sTrescPrawidlowa
//												( kopia utworzonej automatycznie )
String		sTrescKorygowanaUtworzona
String		sTrescPrawidlowaUtworzona

String		sSekcja
String		sSekcjaIn

Int			iFirmDataRead = 0				// odczytano dane z XML'a z repozytorium ?
											// dane firmy z dokumentu korygowanego ( oryginalnego )
String		strFirmName
String		strFirmAddress
String		strFirmNIP

#include	"Formatka do wyboru bitmapy"
#include	"Wydruki - include"

Int			ShowWarning = 1

//--------------------------------------------------------------------------------
// Pobierz nazwe firmy z dokumentu prawidlowego ( korygujacego )

String Sub NazwaFirmyDokumentPrawidlowy( rDokumentSp Dokument, rKontrahent Firma )

	String CompanyName = ""

	If !GetDzial( "BDzial", Dokument.dzial.kod ) Then
		If Dzial.wydrukSYNTAX Then
			// z dzialu
			CompanyName = Dzial.nazwa
		EndIf
	Endif
	If !Len( CompanyName ) Then
		// z firmy
		CompanyName = Firma.nazwa
	EndIf

	NazwaFirmyDokumentPrawidlowy = CompanyName
	
EndSub
	
//--------------------------------------------------------------------------------
// Pobierz adres firmy z dokumentu prawidlowego ( korygujacego )

String Sub AdresFirmyDokumentPrawidlowy( rDokumentSp Dokument, rKontrahent Firma )

	String CompanyAddress = ""

	If !GetDzial( "BDzial", Dokument.dzial.kod ) Then
		If Dzial.wydrukSYNTAX Then
			// z dzialu
			CompanyAddress = Dzial.adres + LF + Dzial.kodPocztowy + " " + Dzial.miejscowosc
		EndIf
	Endif
	If !Len( CompanyAddress ) Then
		// z firmy
		CompanyAddress = Firma.adres + LF + Firma.kodPocztowy + " " + Firma.miejscowosc

	EndIf
	CompanyAddress += IIF( AMStrCMpi( FIRMA_KRAJ, Dokument.danekh.kraj.nazwa ), LF + FIRMA_KRAJ, "" )
	
	AdresFirmyDokumentPrawidlowy = CompanyAddress
	
EndSub
	
//--------------------------------------------------------------------------------
// Pobierz NIP firmy z dokumentu prawidlowego ( korygujacego )

String Sub NipFirmyDokumentPrawidlowy( rDokumentSp Dokument, rKontrahent Firma )

	NipFirmyDokumentPrawidlowy = Firma.NIP
	
EndSub

//--------------------------------------------------------------------------------
// Pobierz nazwe, adres, NIP firmy z dokumentu korygowanego ( oryginalnego ) z XML'a w repozytorium

Int Sub NazwaAdresNipFirmyDokKoryg( rDokumentSp Dokument, rKontrahent Firma )

	Dispatch	bDocument = xFactory.NewObject( "BDokumentSp" )
	Dispatch	xRow = xFactory.NewObject( "XStrRW" )
	Int			iResult = !ReadFromRepository
	
	// Tylko jedno odwolanie do repozytorium w celu odczytania wszystkich niezbednych danych z oryginalu
	iFirmDataRead = 1
	
	If !iResult Then
		bDocument.Load() 
		xRow.Load()
		xRow.kod = Using "GUID='%s'", Dokument.Guid
		bDocument.PobierzDaneFirmyDokumentu( xRow )
		iResult = !xRow.GetField( "FirmDataRead" )
	Else
		ShowWarning = 0
	EndIf
	
	If !iResult Then
		strFirmName = xRow.GetField( "FirmName" )	
		strFirmAddress = xRow.GetField( "FirmAddress" ) + LF + xRow.GetField( "FirmPostCode" ) + " " + xRow.GetField( "FirmPlace" )
		strFirmAddress += IIF( AMStrCMpi( FIRMA_KRAJ, xRow.GetField( "FirmCountry" ) ), LF + FIRMA_KRAJ, "" )
		strFirmNIP = xRow.GetField( "FirmNIP" )
	Else
		// Nie mozna odczytac danych z XML'a dokumentu w repozytorium
		// Lepsze dane z korekty niz puste ...
		strFirmName = NazwaFirmyDokumentPrawidlowy( Dokument, Firma )
		strFirmAddress = AdresFirmyDokumentPrawidlowy( Dokument, Firma )
		strFirmNIP = NipFirmyDokumentPrawidlowy( Dokument, Firma )
		ClearINFOs()
		If ShowWarning Then
			AddWarning( "Na wydruku zostan umieszczone dane sprzedawcy z dokumentu poprawnego." )
			ShowINFOs( "Wydruk noty korygujcej", "Nie mona odczyta danych sprzedawcy z dokumentu korygowanego.", 255, 0 )
			ShowWarning = 0
		EndIf
	EndIf
	
	NazwaAdresNipFirmyDokKoryg = iResult

EndSub

//--------------------------------------------------------------------------------
// Pobierz nazwe firmy z dokumentu korygowanego ( oryginalnego )

String Sub NazwaFirmyDokumentKorygowany( rDokumentSp Dokument, rKontrahent Firma )

	If !iFirmDataRead Then
		NazwaAdresNipFirmyDokKoryg( Dokument, Firma )
	Endif
		
	NazwaFirmyDokumentKorygowany = strFirmName

EndSub

//--------------------------------------------------------------------------------
// Pobierz adres firmy z dokumentu korygowanego ( oryginalnego )

String Sub AdresFirmyDokumentKorygowany( rDokumentSp Dokument, rKontrahent Firma )

	If !iFirmDataRead Then
		NazwaAdresNipFirmyDokKoryg( Dokument, Firma )
	Endif

	AdresFirmyDokumentKorygowany = strFirmAddress

EndSub

//--------------------------------------------------------------------------------
// Pobierz NIP firmy z dokumentu korygowanego ( oryginalnego )

String Sub NipFirmyDokumentKorygowany( rDokumentSp Dokument, rKontrahent Firma )

	If !iFirmDataRead Then
		NazwaAdresNipFirmyDokKoryg( Dokument, Firma )
	Endif

	NipFirmyDokumentKorygowany = strFirmNIP
	
EndSub

//--------------------------------------------------------------------------------
// Wyciecie poczatkowych bialych znakow

String Sub LTrim( String Tekst )
	Int		pozTmp
	String	bufTmp

	// Zapamietanie ustawien bufora
	pozTmp = Move 0
	bufTmp = buf
	
	// Wyciecie koncowych bialych znakow
	buf = Tekst
	Delete Regular "^:b"
	LTrim = buf

	// Odtworzenie ustawienia bufora
	buf = bufTmp
	Move To pozTmp
EndSub

//--------------------------------------------------------------------------------
// Wyciecie koncowych bialych znakow

String Sub RTrim( String Tekst )
	Int		pozTmp
	String	bufTmp

	// Zapamietanie ustawien bufora
	pozTmp = Move 0
	bufTmp = buf
	
	// Wyciecie koncowych bialych znakow
	buf = Tekst
	Delete Regular ":b$"
	RTrim = buf

	// Odtworzenie ustawienia bufora
	buf = bufTmp
	Move To pozTmp
EndSub

//--------------------------------------------------------------------------------
// Wyciecie poczatkowych i koncowych bialych znakow

String Sub Trim( String Tekst )
	Trim = RTrim( LTrim( Tekst ) )
EndSub

//--------------------------------------------------------------------------------
// Domyslne wartosci ustawien wydruku

Int Sub SetDefaultIni()

	iNazwaSprzedawcy = 1
	iDaneAdresoweSprzedawcy = 1
	iNipSprzedawcy = 1
	iNazwaNabywcy = 1
	iDaneAdresoweNabywcy = 1
	iNipNabywcy = 1
	iNazwaOdbiorcy = 0
	iDaneAdresoweOdbiorcy = 0
	iDataWystawienia = 0
	iDataSprzedazy = 1
	iRejestrFormaPlatnosci = 1
	iOpisDokumentu = 0
	iNotatkaDokumentu = 0
	iZmienioneOpisyPozycji = 0
	iDrukujOpisTypuDokumentu = 1

EndSub

//--------------------------------------------------------------------------------
// Zapisanie do pliku INI dlugiego tekstu
// Dzielenie na 250 znakowe tokeny z racji rozmiaru kolumny w tabeli INIFILE ( linia Forte )

String Sub PutIniLongString( String sekcja, String wejscie, String wartosc )

	Int		Ind
	Int		pozTmp
	String	bufTmp
	String	Token

	// Zapamietanie ustawien bufora
	pozTmp = Move 0
	bufTmp = buf

	Ind = 1
	buf = wartosc
	While Len( buf )
		Token = Mid( buf, 1, TOKEN_MAX_LEN )
		PutIni( SEKCJA_INI, ( Using "%s%03d", wejscie, Ind ), Token )
		Delete Token
		Ind += 1
	Wend

	// Odtworzenie ustawienia bufora
	buf = bufTmp
	Move To pozTmp

EndSub

//--------------------------------------------------------------------------------
// Wyczyszczenie odczytanego / Odczytanie z pliku INI dlugiego tekstu

String Sub ClearGetIniLongString( String sekcja, String wejscie, Int odczytaj )

	Int		Ind
	String	Result
	String	Token

	Result = ""
	Ind = 1
	While 1
		Token = GetIni( SEKCJA_INI, ( Using "%s%03d", wejscie, Ind ) )
		If Len( Token ) Then
			If odczytaj Then
				Result += Token
			Else
				PutIni( SEKCJA_INI, ( Using "%s%03d", wejscie, Ind ), "" )
			EndIf
			Ind += 1
		Else
			Exit
		EndIf
	Wend
	ClearGetIniLongString = Result

EndSub

//--------------------------------------------------------------------------------
// Wyczyszczenie odczytanego z pliku INI dlugiego tekstu

String Sub ClearIniLongString( String sekcja, String wejscie )
	
	ClearIniLongString = ClearGetIniLongString( sekcja, wejscie, 0 )

EndSub

//--------------------------------------------------------------------------------
// Odczytanie z pliku INI dlugiego tekstu

String Sub GetIniLongString( String sekcja, String wejscie )
	
	GetIniLongString = ClearGetIniLongString( sekcja, wejscie, 1 )

EndSub

//--------------------------------------------------------------------------------
// Odczytanie / zapisanie do pliku INI pojedynczej wartosci calkowitej ustawien wydruku

Int Sub GetPutIniInt( String sekcja, String wejscie, Int wartosc, Int zapis )

	String GetValue

	If zapis Then
		PutIni( sekcja, wejscie, ( Using "%d", wartosc ) )
		GetPutIniInt = wartosc
	Else
		GetValue = GetIni( sekcja, wejscie )
		GetPutIniInt = IIF( GetValue == "", -1, Val( GetValue ) )
	EndIf

EndSub

//--------------------------------------------------------------------------------
// Odczytanie / zapisanie do pliku INI wszystkich wartosci ustawien wydruku

Int Sub GetPutIniAll( Int zapis )


	iNazwaSprzedawcy = GetPutIniInt( SEKCJA_INI, "Nazwa sprzedawcy", iNazwaSprzedawcy, zapis )
	iDaneAdresoweSprzedawcy = GetPutIniInt( SEKCJA_INI, "Dane adresowe sprzedawcy", iDaneAdresoweSprzedawcy, zapis )
	iNipSprzedawcy = GetPutIniInt( SEKCJA_INI, "NIP sprzedawcy", iNipSprzedawcy, zapis )
	iNazwaNabywcy = GetPutIniInt( SEKCJA_INI, "Nazwa nabywcy", iNazwaNabywcy, zapis )
	iDaneAdresoweNabywcy = GetPutIniInt( SEKCJA_INI, "Dane adresowe nabywcy", iDaneAdresoweNabywcy, zapis )
	iNipNabywcy = GetPutIniInt( SEKCJA_INI, "NIP nabywcy", iNipNabywcy, zapis )
	iNazwaOdbiorcy = GetPutIniInt( SEKCJA_INI, "Nazwa odbiorcy", iNazwaOdbiorcy, zapis )
	iDaneAdresoweOdbiorcy = GetPutIniInt( SEKCJA_INI, "Dane adresowe odbiorcy", iDaneAdresoweOdbiorcy, zapis )
#ifndef HIDE_INVOICE_DATE
	iDataWystawienia = GetPutIniInt( SEKCJA_INI, "Data wystawienia", iDataWystawienia, zapis )
#else
	iDataWystawienia = 0
#endif
	iDataSprzedazy = GetPutIniInt( SEKCJA_INI, "Data sprzedazy", iDataSprzedazy, zapis )
	iRejestrFormaPlatnosci = GetPutIniInt( SEKCJA_INI, "Rejestr i forma platnosci", iRejestrFormaPlatnosci, zapis )
	iOpisDokumentu = GetPutIniInt( SEKCJA_INI, "Opis dokumentu", iOpisDokumentu, zapis )
	iNotatkaDokumentu = GetPutIniInt( SEKCJA_INI, "Notatka dokumentu", iNotatkaDokumentu, zapis )
	iZmienioneOpisyPozycji = GetPutIniInt( SEKCJA_INI, "Zmienione opisy pozycji", iZmienioneOpisyPozycji, zapis )
	iDrukujOpisTypuDokumentu = GetPutIniInt( SEKCJA_INI, "Drukuj opis typu jako nazwe dokumentu", iDrukujOpisTypuDokumentu, zapis )

	// Informacje zapisywane do pliku INI jako paczka - sprawdzenie tylko jednej z nich
	If !zapis && iNazwaSprzedawcy == -1 Then
		// Ustawienia wydruku nie zostaly zapisane do pliku INI - ustawienie domyslnych wartosci
		SetDefaultIni()
	EndIf

EndSub

//--------------------------------------------------------------------------------
// Odczytanie danych dokumenty korygowanego / prawidlowego

Int Sub DokumentKorygowanyPrawidlowy()
	
	Long	IdDokKorygowany

	GetPrawidlowyDokumentSp( "BDokumentSp", lIdDok )

	IdDokKorygowany = GetIdDokumentuKorygowanego( DokumentPrawidlowy )

	GetKorygowanyDokumentSp( "BDokumentSp", IdDokKorygowany )

EndSub

//--------------------------------------------------------------------------------
// Utworzenie tresci korygowanej i prawidlowej

Int Sub TrescKorygowanaPrawidlowa()

	Int			Ind
	Int			PrintNPkorygowane
	Int			PrintNPprawidlowe
	String		Adres
	String		OpisKorygowany
	String		OpisPrawidlowy
	String		PozycjeKorygowane
	String		PozycjePrawidlowe
	String		Rachunek

	sTrescKorygowana = ""
	sTrescPrawidlowa = ""
	If iNazwaSprzedawcy Then
		sTrescKorygowana += ( Using "%s%s%s", T_INFO_SPRZEDAWCA, NazwaFirmyDokumentKorygowany( DokumentKorygowany, xFirmaKorygowany ), NL )
		sTrescPrawidlowa += ( Using "%s%s%s", T_INFO_SPRZEDAWCA, NazwaFirmyDokumentPrawidlowy( DokumentPrawidlowy, xFirmaKorygowany ), NL )
	EndIf
	If iDaneAdresoweSprzedawcy Then
		sTrescKorygowana += IIF( iNazwaSprzedawcy, T_INFO_TAB_DANE, ( Using "%s", T_INFO_ADRES_SPRZEDAWCY ) )
		sTrescKorygowana += ( Using "%s%s", AdresFirmyDokumentKorygowany( DokumentKorygowany, xFirmaKorygowany ), NL )
		sTrescPrawidlowa += IIF( iNazwaNabywcy, T_INFO_TAB_DANE, ( Using "%s", T_INFO_ADRES_SPRZEDAWCY ) )
		sTrescPrawidlowa += ( Using "%s%s", AdresFirmyDokumentPrawidlowy( DokumentPrawidlowy, xFirmaKorygowany ), NL )
	EndIf
	If iNipSprzedawcy Then
		sTrescKorygowana += ( Using "%s%s%s", T_INFO_NIP_SPRZEDAWCY, NipFirmyDokumentKorygowany( DokumentKorygowany, xFirmaKorygowany ), NL )
		sTrescPrawidlowa += ( Using "%s%s%s", T_INFO_NIP_SPRZEDAWCY, NipFirmyDokumentPrawidlowy( DokumentPrawidlowy, xFirmaKorygowany ), NL )
	EndIf
	If iNazwaNabywcy Then
		sTrescKorygowana += ( Using "%s%s%s", T_INFO_NABYWCA, DokumentKorygowany.danekh.KhNazwa, NL )
		sTrescPrawidlowa += ( Using "%s%s%s", T_INFO_NABYWCA, DokumentPrawidlowy.danekh.KhNazwa, NL )
	EndIf
	If iDaneAdresoweNabywcy Then
		sTrescKorygowana += IIF( iNazwaNabywcy, T_INFO_TAB_DANE, ( Using "%s", T_INFO_ADRES_NABYWCY ) )
		Adres = DokumentKorygowany.danekh.KhAdres
		If Len( DokumentKorygowany.danekh.KhPoczta ) || Len( DokumentKorygowany.danekh.KhMiasto ) Then
			Adres += ( Using IIF( Len( Adres ), ",  %s %s", "%s %s" ), DokumentKorygowany.danekh.KhPoczta, DokumentKorygowany.danekh.KhMiasto )
		EndIf
		If Len( DokumentKorygowany.danekh.kraj.nazwa ) Then
			Adres += ( Using IIF( Len( Adres ), ",  %s", "%s" ), DokumentKorygowany.danekh.kraj.nazwa )
		EndIf
		sTrescKorygowana += ( Using "%s%s", Adres, NL )
		sTrescPrawidlowa += IIF( iNazwaNabywcy, T_INFO_TAB_DANE, ( Using "%s", T_INFO_ADRES_NABYWCY ) )
		Adres = DokumentPrawidlowy.danekh.KhAdres
		If Len( DokumentPrawidlowy.danekh.KhPoczta ) || Len( DokumentPrawidlowy.danekh.KhMiasto ) Then
			Adres += ( Using IIF( Len( Adres ), ",  %s %s", "%s %s" ), DokumentPrawidlowy.danekh.KhPoczta, DokumentPrawidlowy.danekh.KhMiasto )
		EndIf
		If Len( DokumentPrawidlowy.danekh.kraj.nazwa ) Then
			Adres += ( Using IIF( Len( Adres ), ",  %s", "%s" ), DokumentPrawidlowy.danekh.kraj.nazwa )
		EndIf
		sTrescPrawidlowa += ( Using "%s%s", Adres, NL )
	EndIf
	If iNipNabywcy Then
		sTrescKorygowana += ( Using "%s%s%s", T_INFO_NIP_NABYWCY, DokumentKorygowany.danekh.KhNIP, NL )
		sTrescPrawidlowa += ( Using "%s%s%s", T_INFO_NIP_NABYWCY, DokumentPrawidlowy.danekh.KhNIP, NL )
	EndIf
	If iNazwaOdbiorcy Then
		sTrescKorygowana += ( Using "%s%s%s", T_INFO_ODBIORCA, DokumentKorygowany.daneod.KhNazwa, NL )
		sTrescPrawidlowa += ( Using "%s%s%s", T_INFO_ODBIORCA, DokumentPrawidlowy.daneod.KhNazwa, NL )
	EndIf
	If iDaneAdresoweOdbiorcy Then
		sTrescKorygowana += IIF( iNazwaOdbiorcy, T_INFO_TAB_DANE, ( Using "%s", T_INFO_ADRES_ODBIORCY ) )
		Adres = DokumentKorygowany.daneod.KhAdres
		If Len( DokumentKorygowany.daneod.KhPoczta ) || Len( DokumentKorygowany.daneod.KhMiasto ) Then
			Adres += ( Using IIF( Len( Adres ), ",  %s %s", "%s %s" ), DokumentKorygowany.daneod.KhPoczta, DokumentKorygowany.daneod.KhMiasto )
		EndIf
		If Len( DokumentKorygowany.daneod.kraj.nazwa ) Then
			Adres += ( Using IIF( Len( Adres ), ",  %s", "%s" ), DokumentKorygowany.daneod.kraj.nazwa )
		EndIf
		sTrescKorygowana += ( Using "%s%s", Adres, NL )
		sTrescPrawidlowa += IIF( iNazwaOdbiorcy, T_INFO_TAB_DANE, ( Using "%s", T_INFO_ADRES_ODBIORCY ) )
		Adres = DokumentPrawidlowy.daneod.KhAdres
		If Len( DokumentPrawidlowy.daneod.KhPoczta ) || Len( DokumentPrawidlowy.daneod.KhMiasto ) Then
			Adres += ( Using IIF( Len( Adres ), ",  %s %s", "%s %s" ), DokumentPrawidlowy.daneod.KhPoczta, DokumentPrawidlowy.daneod.KhMiasto )
		EndIf
		If Len( DokumentPrawidlowy.daneod.kraj.nazwa ) Then
			Adres += ( Using IIF( Len( Adres ), ",  %s", "%s" ), DokumentPrawidlowy.daneod.kraj.nazwa )
		EndIf
		sTrescPrawidlowa += ( Using "%s%s", Adres, NL )
	EndIf
	If iDataWystawienia Then
		sTrescKorygowana += ( Using "%s%s%s", T_INFO_DATA_WYSTAWIENIA, DokumentKorygowany.dataWystawienia, NL )
		sTrescPrawidlowa += ( Using "%s%s%s", T_INFO_DATA_WYSTAWIENIA, DokumentPrawidlowy.dataWystawienia, NL )
	EndIf
	If iDataSprzedazy Then
		sTrescKorygowana += ( Using "%s%s%s", T_INFO_DATA_SPRZEDAZY, DokumentKorygowany.dataSprzedazy, NL )
		sTrescPrawidlowa += ( Using "%s%s%s", T_INFO_DATA_SPRZEDAZY, DokumentPrawidlowy.dataSprzedazy, NL )
	EndIf
	If iRejestrFormaPlatnosci Then
		Rachunek = ""
		If DokumentKorygowany.rejestr.typRejestru Then
			// Rejestr typu bankowy lub inny - drukuj numer konta
			If !GetRejestr( "BRejestr", DokumentKorygowany.rejestr.id ) Then
				Rachunek = ( Using "%s  /  ", Rejestr.rachunek )
			EndIf
		EndIf
		sTrescKorygowana += ( Using "%s%s  /  %s      %s%s%s", T_INFO_REJESTR_FORMA_PLATNOSCI, DokumentKorygowany.rejestr.kod, DokumentKorygowany.formaPl.nazwa, Rachunek, DokumentKorygowany.terminPlatnosci, NL )
		Rachunek = ""
		If DokumentPrawidlowy.rejestr.typRejestru Then
			// Rejestr typu bankowy lub inny - drukuj numer konta
			If !GetRejestr( "BRejestr", DokumentPrawidlowy.rejestr.id ) Then
				Rachunek = ( Using "%s  /  ", Rejestr.rachunek )
			EndIf
		EndIf
		sTrescPrawidlowa += ( Using "%s%s  /  %s      %s%s%s", T_INFO_REJESTR_FORMA_PLATNOSCI, DokumentPrawidlowy.rejestr.kod, DokumentPrawidlowy.formaPl.nazwa, Rachunek, DokumentPrawidlowy.terminPlatnosci, NL )
	EndIf
	If iOpisDokumentu Then
		buf = RTrim( DokumentKorygowany.opis )
		sTrescKorygowana += ( Using "%s%s%s", T_INFO_OPIS_DOKUMENTU, buf, NL )
		buf = RTrim( DokumentPrawidlowy.opis )
		sTrescPrawidlowa += ( Using "%s%s%s", T_INFO_OPIS_DOKUMENTU, buf, NL )
	EndIf
	If iNotatkaDokumentu Then
		buf = DokumentKorygowany.notatka
		While Replace NL, ( Using "%s%s", NL, T_INFO_TAB_DANE )
			Move 1
		Wend
		Delete Regular ":b$"
		sTrescKorygowana += ( Using "%s%s%s", T_INFO_NOTATKA_DOKUMENTU, buf, NL )
		buf = DokumentPrawidlowy.notatka
		While Replace NL, ( Using "%s%s", NL, T_INFO_TAB_DANE )
			Move 1
		Wend
		Delete Regular ":b$"
		sTrescPrawidlowa += ( Using "%s%s%s", T_INFO_NOTATKA_DOKUMENTU, buf, NL )
	EndIf

	If iZmienioneOpisyPozycji Then
		// Tekst "Pozycje nie podlegajace VAT" przed pierwsza zmieniona pozycja NP 
		PrintNPkorygowane = 1
		PrintNPprawidlowe = 1
		PozycjeKorygowane = ""
		PozycjePrawidlowe = ""

		For Ind = 1 To Ind > DokumentPozycjeCount( DokumentPrawidlowy )
			// Bez drukowania zmienionych opisow skladnikow kompletu
			If !DokumentPrawidlowy.Pozycje_item( Ind ).dokompletu Then
				OpisKorygowany = RTrim( DokumentPrawidlowy.Pozycje_item( Ind ).PrzedKorekta.opis )
				OpisPrawidlowy = RTrim( DokumentPrawidlowy.Pozycje_item( Ind ).PoKorekcie.opis )
				// Rozne opisy pozycji lub nowa pozycja na korekcie
				If AMStrCMpi( OpisKorygowany, OpisPrawidlowy ) || DokumentPrawidlowy.Pozycje_item( Ind ).PrzedKorekta.id == 0 Then
					If AMStrCMpi( OpisKorygowany, OpisPrawidlowy ) Then
						If PrintNPkorygowane && ( DokumentPrawidlowy.Pozycje_item( Ind ).PrzedKorekta.stVAT.typ == STVAT_NIEPODLEGA ) Then
							PozycjeKorygowane += ( Using "\t%s%s", T_INFO_POZYCJE_NP, NL )
							PrintNPkorygowane = 0
						EndIf
						PozycjeKorygowane += ( Using "%d.\t%s%s", DokumentPrawidlowy.Pozycje_item( Ind ).PrzedKorekta.Lp, OpisKorygowany, NL )
					EndIf
					If PrintNPprawidlowe && ( DokumentPrawidlowy.Pozycje_item( Ind ).PoKorekcie.stVAT.typ == STVAT_NIEPODLEGA ) Then
						PozycjePrawidlowe += ( Using "\t%s%s", T_INFO_POZYCJE_NP, NL )
						PrintNPprawidlowe = 0
					EndIf
					PozycjePrawidlowe += ( Using "%d.\t%s%s", DokumentPrawidlowy.Pozycje_item( Ind ).PoKorekcie.Lp, OpisPrawidlowy, NL )
				EndIf
			EndIf
		Next Ind

		buf = PozycjeKorygowane
		While Replace NL, ( Using "%s%s", NL, T_INFO_TAB_NR_POZYCJI )
			Move 1
		Wend
		sTrescKorygowana += ( Using "%s%s", T_INFO_OPISY_POZYCJI, buf )

		buf = PozycjePrawidlowe
		While Replace NL, ( Using "%s%s", NL, T_INFO_TAB_NR_POZYCJI )
			Move 1
		Wend
		sTrescPrawidlowa += ( Using "%s%s", T_INFO_OPISY_POZYCJI, buf )
	EndIf

	sTrescKorygowana = RTrim( sTrescKorygowana )
	sTrescKorygowanaUtworzona = sTrescKorygowana
	sTrescPrawidlowa = RTrim( sTrescPrawidlowa )
	sTrescPrawidlowaUtworzona = sTrescPrawidlowa

EndSub

//--------------------------------------------------------------------------------
// Okno z proponowana trescia korygowana i prawidlowa

Int Sub OknoTrescKorygowanaPrawidlowa()

	Int UtworzTresc
	
	// Przepisanie wartosci checkbox'ow z okna ustawienia wydruku
	Save

	sTrescKorygowana = RTrim( sTrescKorygowana )
	sTrescPrawidlowa = RTrim( sTrescPrawidlowa )

	// Utworzenie tresci za pierwszym razem, jesli zaproponowane zostaly calkowicie usuniete lub nie zostaly zmodyfikowane
	UtworzTresc = ( Len( sTrescKorygowana ) == 0 && Len( sTrescPrawidlowa ) == 0 )
	UtworzTresc += ( !AMStrCMpi( sTrescKorygowana, sTrescKorygowanaUtworzona ) && !AMStrCMpi( sTrescPrawidlowa, sTrescPrawidlowaUtworzona ) )

	If UtworzTresc Then
		TrescKorygowanaPrawidlowa()
	EndIf

	Form "Tre korygowana / Tre prawidowa", 630, 445
		Text "Tre &korygowana", 10, 10, 120, 15
		MEdit "", sTrescKorygowana, 10, 30, 605, 155
		Text "Tre &prawidowa", 10, 195, 120, 15
		MEdit "", sTrescPrawidlowa, 10, 215, 605, 155
		Button "&OK",    415, 380, 95, 28, OK
		Button "&Anuluj",520, 380, 95, 28, ANULUJ

	ExecForm

	sTrescKorygowana = Trim( sTrescKorygowana )
	sTrescPrawidlowa = Trim( sTrescPrawidlowa )

EndSub

//--------------------------------------------------------------------------------
// Okno z ustawieniami wydruku

Int Sub OknoUstawieniaWydruku()

	Int	deltaY

	Form "Ustawienia wydruku noty korygujcej", 680, 258 + dY
		Group "Zmiany wyszczeglnione w sekcji 'Tre korygowana / Tre prawidowa'", 10, 10, 655, 85
		Group "", 10, 87, 329, 58
		Group "", 336, 87, 329, 58

		ChkBox "Nazwa sprzeda&wcy", iNazwaSprzedawcy, 20, 30, 115, 15
		ChkBox "Dane adresowe sprzedaw&cy", iDaneAdresoweSprzedawcy, 20, 50, 155, 15
		ChkBox "&NIP sprzedawcy", iNipsprzedawcy, 20, 70, 100, 15

		ChkBox "Nazwa na&bywcy", iNazwaNabywcy, 195, 30, 100, 15
		ChkBox "Dane adr&esowe nabywcy", iDaneAdresoweNabywcy, 195, 50, 140, 15
		ChkBox "N&IP nabywcy", iNipNabywcy, 195, 70, 85, 15

		ChkBox "Na&zwa odbiorcy", iNazwaOdbiorcy, 360, 30, 95, 15
		ChkBox "Dane adresowe odbiorc&y", iDaneAdresoweOdbiorcy, 360, 50, 140, 15

#ifndef HIDE_INVOICE_DATE
		ChkBox "Data &wystawienia", iDataWystawienia, 345, 30, 105, 15
		deltaY = 0
#else
		deltaY = -20
#endif
		ChkBox "Data &sprzeday", iDataSprzedazy, 520, 50 + deltaY, 95, 15
		ChkBox "&Rejestr i forma patnoci", iRejestrFormaPlatnosci, 520, 70 + deltaY, 140, 15

		ChkBox "Opis doku&mentu", iOpisDokumentu, 20, 100, 100, 15
		ChkBox "Notat&ka dokumentu", iNotatkaDokumentu, 20, 120, 115, 15

		ChkBox "Zmienione opisy &pozycji", iZmienioneOpisyPozycji, 360, 100, 135, 15

		ChkBox "&Drukuj opis typu jako nazw dokumentu", iDrukujOpisTypuDokumentu, 20, 158, 210, 15

		If GRAFICZNY Then
			Button "Ustawienia symbolu &graficznego", 20,190, 310, 28, BitmapSet2()
		EndIf
		Button "&Tre korygowana / Tre prawidowa", 347, 150 + dY, 310, 28, OknoTrescKorygowanaPrawidlowa()

		Button "&OK",    435, 193 + dY, 105, 28, OK
		Button "&Anuluj",552, 193 + dY, 105, 28, ANULUJ

	OknoUstawieniaWydruku = ExecForm

EndSub

//--------------------------------------------------------------------------------
// MAIN

If lIdDok == 0 Then
	Message "Raport mona wykona tylko z okna dokumentu"
	Error ""
EndIf

DokumentKorygowanyPrawidlowy()

if DokumentPrawidlowy.DataWystawienia < xFirmaPrawidlowy.dataOd || DokumentPrawidlowy.DataWystawienia > xFirmaPrawidlowy.dataDo then
	If ReadFromRepository Then
		xParamsFirm = xFactory.NewObject("BParamsFirma")	
		xParamsFirm.data = DokumentPrawidlowy.DataWystawienia
		xFirmaPrawidlowy = xFactory.NewObject("BFirma")
		xFirmaPrawidlowy.LoadSYNTAX(xParamsFirm)
	EndIf
endif
if DokumentKorygowany.DataWystawienia < xFirmaKorygowany.dataOd || DokumentKorygowany.DataWystawienia > xFirmaKorygowany.dataDo then
	If ReadFromRepository Then
		xParamsFirm = xFactory.NewObject("BParamsFirma")	
		xParamsFirm.data = DokumentKorygowany.DataWystawienia
		xFirmaKorygowany = xFactory.NewObject("BFirma")
		xFirmaKorygowany.LoadSYNTAX(xParamsFirm)
	EndIf
endif

IloscKopii = Val( GetIni( DokumentPrawidlowy.TypDk, KLUCZ_ILOSC_KOPII ) )

// Odczytanie ustawien wydruku z pliku INI
GetPutIniAll( 0 )

If GetCurrentRun() > 1 Then
	// Kolejne wywolanie dla kopii dokumentu
	// Odczytanie z pliku INI tresci korygowanej / prawidlowej
	sTrescKorygowana = GetIniLongString( SEKCJA_INI, "Tresc korygowana" )
	sTrescPrawidlowa = GetIniLongString( SEKCJA_INI, "Tresc prawidlowa" )
	// Usuniecie z pliku INI tresci korygowanej / prawidlowej
	ClearIniLongString( SEKCJA_INI, "Tresc korygowana" )
	ClearIniLongString( SEKCJA_INI, "Tresc prawidlowa" )
Else
	// Pierwszy wydruk
	sTrescKorygowana = ""
	sTrescPrawidlowa = ""
	sTrescKorygowanaUtworzona = ""
	sTrescPrawidlowaUtworzona = ""

	If Val( Arg7 ) == 1 Then
		If OknoUstawieniaWydruku() == ANULUJ Then
			Error ""
		EndIf
	EndIf

	// Zapisanie ustawien wydruku do pliku INI
	GetPutIniAll( 1 )

	If !AMStrCMpi( sTrescKorygowana, sTrescKorygowanaUtworzona ) && !AMStrCMpi( sTrescPrawidlowa, sTrescPrawidlowaUtworzona ) Then
		// Tresc korygowana / prawidlowa nie zostala zmodyfikowana przez uzytkownika ( lub nie byla utworzona )
		// Ponowne utworzenie aby uwzglednic koncowe ustawienia checkbox'ow
		TrescKorygowanaPrawidlowa()
	EndIf

	If ( Val( Arg2 ) == 0 ) && ( Val( Arg3 ) == 1 || Val( Arg3 ) == 5 ) && ( IloscKopii > 1 ) Then
		//	Dokument wystawiony
		//						Oryginal+Kopia || Duplikat(Oryginal+Kopia)
		//																	Bedzie kolejne wywolanie raportu
		// Usuniecie z pliku INI tresci korygowanej / prawidlowej ( pozostalosci po wczesniejszym np. przerwanym raporcie )
		ClearIniLongString( SEKCJA_INI, "Tresc korygowana" )
		ClearIniLongString( SEKCJA_INI, "Tresc prawidlowa" )
		// Zapisanie tresci korygowanej / prawidlowej na potrzeby wydruku kopii
		PutIniLongString( SEKCJA_INI, "Tresc korygowana", sTrescKorygowana )
		PutIniLongString( SEKCJA_INI, "Tresc prawidlowa", sTrescPrawidlowa )
	EndIf
EndIf
