//"NotaKorW.sci","Nota korygujca - wydruk",12000,0,1.0.2,SYSTEM
//"Dokumenty sprzeday",12400,14,62
//
//"NotaKorW.sc","Nota korygujca - wydruk","\Dokumenty\Sprzeda\",0,1.0.2,SYSTEM

//######################################################
//#     Raporty WSPOLNE dla linii Forte i Symfonia     #
//######################################################

Limit 32767

// Stala wysokosc czcionek z pominieciem definicji w ustawieniach programu ( naglowek i stopka strony )
#define		AVOID_SETTINGS_FONT_SIZE

// Tlo ramki
#define		TRANSPARENT			-1
// Tlo ramki i tabelki
#define		WHITE				Gray( 0 )
#define		BRIGHT				Gray( 20 )
#define		DARK				Gray( 40 )

// Drukowane teksty
#define		INFO_NR						"Nr "
#define		INFO_PIECZEC_FIRMY			"Piecz firmy"
#define		INFO_MIEJSCOWOSC_DATA_WYST	"Miejscowo, data wystawienia"
#define		INFO_WYSTAWCA				"WYSTAWCA"
#define		INFO_SPRZEDAWCA				"SPRZEDAWCA"
#define		INFO_ADRESAT				"ADRESAT"
#define		INFO_NABYWCA				"NABYWCA"
#define		INFO_FIRMA					"Firma"
#define		INFO_ADRES					"Adres"
#define		INFO_NIP					"NIP"
#define		INFO_DANEKORYGOWANE			"DANE ZAWARTE W DOKUMENCIE, KTREGO DOTYCZY NOTA KORYGUJCA"
#define		INFO_KORYGOWANY_NR			"Numer dokumentu"
#define		INFO_KORYGOWANY_DATA_WYST	"Data wystawienia"
#define		INFO_KORYGOWANY_DATA_SPRZ	"Data sprzeday"
#define		INFO_TRESC_KORYGOWANA		"Tre korygowana"
#define		INFO_TRESC_PRAWIDLOWA		"Tre prawidowa"
#define		INFO_AKCEPTACJA_ODBIORCY	"Akceptuj treci zawarte w nocie korygujcej"
#define		INFO_AKCEPTACJA_WYSTAWCY	"Osoba uprawniona do wystawienia noty korygujcej"
#define		INFO_IMIE					"Imi"
#define		INFO_NAZWISKO				"Nazwisko"
#define		INFO_PODPIS					"Podpis"
#define		INFO_Z_DNIA					"z dnia"
#define		INFO_UWAGA					"UWAGA"

#define		HEIGHT_UNIT			65	// Jednostka wysokosci wiersza
#define		SPACE_UNIT			10	// Jednostka odstepu

									// Wysokosc kroju pisma
#define		HEIGHT_TITLE		49	// Tytul raportu
#define		HEIGHT_HEAD			35	// Naglowek kolumny
#define		HEIGHT_DATA			35	// Inna dana
#define		HEIGHT_DESCRIPTION	28	// Opis danej
#define		HEIGHT_FOOT			25	// Stopka strony

									// Fonty
Int			FontTitle				// Tytul raportu
Int			FontHead				// Naglowek kolumny
Int			FontData				// Inna dana
Int			FontDescription			// Opis danej
Int			FontFoot				// Stopka strony

									// Style
Int			StyleTitleC				// Tytul raportu, wyposrodkowany
Int			StyleHeadC				// Naglowek kolumny, wyposrodkowany
Int			StyleDataC				// Inna dana, wyposrodkowana
Int			StyleDataL				// Inna dana, wyrownana do lewej
Int			StyleDescriptionC		// Opis danej, wyposrodkowany
Int			StyleDescriptionL		// Opis danej, wyrownany do lewej

Int			BmpWidth				// Szerokosc miejsca przeznaczonego na bitmape
Int			BmpHeight				// Wysokosc miejsca przeznaczonego na bitmape
Int			Bmp						// Bitmapa
									// Bitmapa ze zmienna wysokoscia i uzytkownik podal wysokosc bitmapy
Int			nBmpCoord2_Set = ( nBmpCoord( 2 ) && nBitmap )

String		TitleText

//----------------------------------------------------------------------------------------------------
// Ustawienia strony, kroje pisma, etc.

Int Sub InicjujWydruk()

	If GRAFICZNY Then
		Str.Wydruk( 0, -1, -1 )
		// Dolny margines nie uwzglednia miejsca na "sNapisWStopce"
		Strona 50, 90, 50, 80
	Else
		Str.Wydruk( 1, -1, -1 )
		// Dolny margines nie uwzglednia miejsca na "sNapisWStopce"
		Strona 50, 100, 50, 100
		// Wydruk tekstowy bez bitmapy
		nBitmap = 0
		bmpStamp = 0
	EndIf

	FontTitle = CopyFont( IIF( GRAFICZNY, "tytu", "5cpi" ), -1, HEIGHT_TITLE )
	FontHead = CopyFont( IIF( GRAFICZNY,  "nagwek", "10cpi" ), -1, HEIGHT_HEAD )
	FontData = CopyFont( IIF( GRAFICZNY,  "tekst", "12cpi" ), -1, HEIGHT_DATA )
	FontDescription = CopyFont( IIF( GRAFICZNY,  "stopka", "17cpi" ), -1, HEIGHT_DESCRIPTION )
	FontFoot = CopyFont( IIF( GRAFICZNY,  "stopka", "17cpi" ), -1, HEIGHT_FOOT )

	StyleTitleC = Styl( FontTitle, 0 )
	StyleHeadC = Styl( FontHead, 0 )
	StyleDataC = Styl( FontData, 0 )
	StyleDataL = Styl( FontData, -1 )
	StyleDescriptionC = Styl( FontDescription, 0 )
	StyleDescriptionL = Styl( FontDescription, -1 )

	If GRAFICZNY Then
		// Max szerokosc miejsca przeznaczonego dla bitmapy
		Select Case nBitmap
			Case 1
				// Bitmapa u gory strony
				BmpWidth = Str.Szer
			Case 2
				// Bitmapa w lewym gornym rogu
				BmpWidth = 0.66 * Str.Szer
			Case Else
				//  Bitmapa w miejscu pieczeci lub brak bitmapy
				BmpWidth = IIF( bmpStamp, 0.33 * Str.Szer, 0 )
		EndSelect
		// Max wysokosc miejsca przeznaczonego dla bitmapy
		BmpHeight = IIF( nBitmap == 2, 4 * HEIGHT_UNIT + 3 * SPACE_UNIT + 3, 3 * HEIGHT_UNIT + 2 * SPACE_UNIT )
	Else
		BmpWidth = 0
		BmpHeight = 0
	EndIf

EndSub

//----------------------------------------------------------------------------------------------------
Int Sub InicjujNaglowek()

	// Umieszczaj w naglowku stron
	If ( iDrukujOpisTypuDokumentu == 1 ) && !GetTypDokumentuSp( "BTypDokumentuSp", DokumentPrawidlowy.typDk ) Then
		// Drukuj opis typu jako nazwe dokumentu
		sNazwaDok = TypDk.opis
	Else
		sNazwaDok = DokumentPrawidlowy.nazwa
	EndIf
	TitleText = sNazwaDok
	sNazwaDok += ( Using " %s%s %s %s\t%s", INFO_NR, DokumentPrawidlowy.Numer, INFO_Z_DNIA, DokumentPrawidlowy.dataWystawienia, Arg9 )

EndSub

//----------------------------------------------------------------------------------------------------
// Ustawienie stopki strony z wyliczeniem ilosci linii potrzebnej do wydrukowania tekstu

Int Sub InicjujStopke()

	Int		CountLines
	Int		pozTmp
	String	bufTmp
	String	stopkaTmp
	String	LineText

	// Zapamietanie ustawien bufora
	pozTmp = Move 0
	bufTmp = buf

	SetFont( FontFoot )

	// Drukuj stopki stron bez daty
	NoDate = 1

	// Utworz / odczytaj napis w stopce strony 
	bNapisWStopce = 0
	sekcjaTypDk = DokumentPrawidlowy.typDk
	GetNapisWStopce()

	buf = sNapisWStopce

	// Zwieksze miejsce przeznaczone na tekst w stopce
	While Len( buf )
		stopkaTmp = buf
		LineText = Mid( stopkaTmp, 1, BreakLine( Str.Szer, HEIGHT_FOOT, 0, stopkaTmp ) )
		CountLines = TextWidth( LineText ) / Str.Szer + 1
		Str.dm += CountLines * ( HEIGHT_FOOT + IIF( GRAFICZNY, 0, 2 * SPACE_UNIT ) )
		Delete LineText
		Delete Regular "^:b"
	Wend

	Str.Ustaw()

	// Odtworzenie ustawienia bufora
	buf = bufTmp
	Move To pozTmp

EndSub

//----------------------------------------------------------------------------------------------------
// Wysokosc kroju pisma
// ( wymaga zgodnosci z wysokoscia uzyta przy definicji stylu )

Int Sub GetStyleHeight( Int StyleId )

	Select Case StyleId
		Case StyleTitleC
				GetStyleHeight = HEIGHT_TITLE
		Case StyleHeadC
				GetStyleHeight = HEIGHT_HEAD
		Case StyleDataC
				GetStyleHeight = HEIGHT_DATA
		Case StyleDataL
				GetStyleHeight = HEIGHT_DATA
		Case StyleDescriptionC
				GetStyleHeight = HEIGHT_DESCRIPTION
		Case StyleDescriptionL
				GetStyleHeight = HEIGHT_DESCRIPTION
		Case Else
				Error "GetStyleHeight(): Unknown style"
	EndSelect

EndSub

//----------------------------------------------------------------------------------------------------
Int Sub KorygujRozmiarPolozenieBitmapy()

	If GRAFICZNY Then
		If !nBitmap Then
			// Brak bitmapy lub scisle okreslone polozenie i rozmiar
			nBmpCoord( 1 ) = 0
			nBmpCoord( 2 ) = 0
			nBmpCoord( 3 ) = 0
			nBmpCoord( 4 ) = 0
		EndIf

		If nBitmap || bmpStamp Then
			// Drukowanie bitmapy
			If nBmpCoord( 1 ) == 0 || nBmpCoord( 1 ) > BmpWidth || bmpStamp Then
				// Szerokosc bitmapy
				nBmpCoord( 1 ) = BmpWidth
			EndIf
			If nBmpCoord( 2 ) == 0 || nBmpCoord( 2 ) > BmpHeight || bmpStamp Then
				// Wysokosc bitmapy
				nBmpCoord( 2 ) = BmpHeight
			EndIf
			If nBmpCoord( 1 ) + nBmpCoord( 3 ) > BmpWidth Then
				// Przesuniecie od lewej
				nBmpCoord( 3 ) = BmpWidth - nBmpCoord( 1 )
			EndIf
			If nBmpCoord( 2 ) + nBmpCoord( 4 ) > BmpHeight Then
				// Przesuniecie od gory
				nBmpCoord( 4 ) = BmpHeight - nBmpCoord( 2 )
			EndIf
		EndIf
	EndIf

EndSub

//----------------------------------------------------------------------------------------------------
Int Sub DrukujBitmape()

	If GRAFICZNY && ( nBitmap || bmpStamp ) Then
		Bmp = Bitmap nBmpCoord( 1 ) - 1, IIF( ( !nBitmap && bmpStamp && ( nBmpCoord( 2 ) > 222 ) ), 222, nBmpCoord( 2 ) ) - 1, sBitmap
		Bitmap #Bmp, At nBmpCoord( 3 ) + 2, nBmpCoord( 4 ) + 2
	EndIf

EndSub

//----------------------------------------------------------------------------------------------------
// Drukowanie ramki z podanymi danymi ( drukowane centralnie w pionie ) i objasnieniem ( drukowane na dole ramki )
// Parametry :
//   ramka :       lewa krawedz, gorna krawedz, szerokosc, wysokosc, grubosc obramowania, tlo
//   dane :        styl, tekst
//   objasnienie : styl, tekst  

Int Sub RamkaTekst( Int FPosX, Int FPosY, Int FWidth, Int FHeight, Int FBorder, Long FBackground, Int DataStyle, String DataText, Int InfoStyle, String InfoText )

	If FBackground == TRANSPARENT || !GRAFICZNY Then
		// Brak tla : ramka przezroczysta || wydruk tekstowy
		Ramka At FPosX, FPosY, FWidth, FHeight, FBorder
	Else
		// Ramka z tlem
		Ramka At FPosX, FPosY, FWidth, FHeight, FBorder, FBackground
	EndIf
			If Len( DataText ) Then
				Print At 0, ( FHeight - GetStyleHeight( DataStyle ) ) / 2;
				SetStyl( DataStyle )
				Print DataText
			EndIf
			If Len( InfoText ) Then
				Print LF
				If Str.Pozycja( #Y ) + GetStyleHeight( InfoStyle ) + SPACE_UNIT < FHeight Then
					// Przesuniecie objasnienia na dol ramki
					Print At 0, FHeight - GetStyleHeight( InfoStyle ) - 2 * SPACE_UNIT;
				EndIf
				SetStyl( InfoStyle )
				Print InfoText
			EndIf
		Koniec

EndSub

//----------------------------------------------------------------------------------------------------
// Drukowanie ramki z tytulem
// Parametry :
//   ramka :       lewa krawedz, gorna krawedz, szerokosc, wysokosc, grubosc obramowania, tlo
//   tytul :       styl, tekst

Int Sub RamkaTytul( Int FPosX, Int FPosY, Int FWidth, Int FHeight, Int FBorder, Long FBackground, Int TitleStyle, String TitleText )

	Int	Lines
	Int	PosY

	// Liczba linii, na ktore zostanie podzielony tytul
	Lines = Len( TitleText ) / IIF( nBitmap == 1, 36, 24 )
	// Drukuj centralnie
	PosY = ( FHeight - GetStyleHeight( TitleStyle ) ) / 2
	// Przesun do gory przy wiekszej ilosci linii
	PosY -= Lines * ( GetStyleHeight( TitleStyle ) / 2 )

	If FBackground == TRANSPARENT || !GRAFICZNY Then
		// Brak tla : ramka przezroczysta || wydruk tekstowy
		Ramka At FPosX, FPosY, FWidth, FHeight, FBorder
	Else
		// Ramka z tlem
		Ramka At FPosX, FPosY, FWidth, FHeight, FBorder, FBackground
	EndIf
			Print At 0, PosY;
			SetStyl( TitleStyle )
			Print TitleText
		Koniec

EndSub

//----------------------------------------------------------------------------------------------------
Int Sub DrukujNaglowekRaportu( String NazwaOpisDokumentu, String OryginalKopiaDuplikatBrak )

	Int		PosX, PosY, ColWidth, RowHeight
	Int		LastPosY
	String	DataText

	KorygujRozmiarPolozenieBitmapy()

	RowHeight = 1.3 * HEIGHT_UNIT
	Select Case nBitmap
		Case 1
			// Bitmapa u gory strony
			ColWidth = ( Str.Szer - SPACE_UNIT ) / 2
			PosX = ColWidth + SPACE_UNIT
			PosY = nBmpCoord( 2 ) + nBmpCoord( 4 ) + SPACE_UNIT
		Case 2
			// Bitmapa w lewym gornym rogu
			ColWidth = Str.Szer - nBmpCoord( 1 ) - nBmpCoord( 3 ) - SPACE_UNIT
			PosX = nBmpCoord( 1 ) + nBmpCoord( 3 ) + SPACE_UNIT
			PosY = Str.Pozycja( #Y )
			// Tytul o zmiennej dlugosci w ramce o zmiennej wysokosci
			// W tym przypadku drukujemy w pierwszej kolejnosci
			RamkaTytul( PosX, PosY, ColWidth, RowHeight, 1, DARK, StyleTitleC, NazwaOpisDokumentu )
			PosY = Str.Pozycja( #B ) + SPACE_UNIT
		Case Else
			// Bitmapa w miejscu pieczeci lub brak bitmapy
			ColWidth = ( Str.Szer - 2 * SPACE_UNIT ) / 3
			PosX = 2 * ( ColWidth + SPACE_UNIT )
			PosY = 0
	EndSelect
	// Najpierw drukujemy informacje, ktorych dlugosc wplywa na wysokosc ramek
	RamkaTekst( PosX, PosY, ColWidth, RowHeight, 1, TRANSPARENT, StyleTitleC, INFO_NR + DokumentPrawidlowy.Numer, 0, "" )
	RamkaTekst( Str.Pozycja( #L ), Str.Pozycja( #B ) + SPACE_UNIT, ColWidth, RowHeight, 0, TRANSPARENT, StyleTitleC, OryginalKopiaDuplikatBrak, 0, "" )
	DataText = xFirmaPrawidlowy.Miejscowosc + IIF( Len( xFirmaPrawidlowy.Miejscowosc ), ", ", "" ) + DokumentPrawidlowy.dataWystawienia
	RamkaTekst( Str.Pozycja( #L ), Str.Pozycja( #B ) + SPACE_UNIT, ColWidth, RowHeight, 1, TRANSPARENT, StyleDataC, DataText, StyleDescriptionC, INFO_MIEJSCOWOSC_DATA_WYST )
	If GRAFICZNY && !nBmpCoord2_Set Then
		// Dopasowujemy wysokosc bitmapy, miejsca na pieczec, naglowka wydruku, ...
		nBmpCoord( 2 ) = Str.Pozycja( #B )
		BmpHeight = IIF( nBitmap != 1 || bmpStamp == 1, Str.Pozycja( #B ), BmpHeight )
		KorygujRozmiarPolozenieBitmapy()
	EndIf
	PosX -= IIF( nBitmap == 2, 0, ColWidth + SPACE_UNIT )
	LastPosY = PosY
	PosY -= IIF( nBitmap == 2, RowHeight + SPACE_UNIT, 0 )
	RowHeight = IIF( nBitmap == 2, RowHeight, Str.Pozycja( #B ) - LastPosY )
	LastPosY = Str.Pozycja( #B )
	// Teraz drukujemy odpowiednio rozciagniete / dopasowane pozostale ramki
	If nBitMap != 2 Then
		// Wysokosc ramki wystarczajaca do zmieszczenia najdluzszego tytulu
		RamkaTytul( PosX, PosY, ColWidth, RowHeight, 1, DARK, StyleTitleC, NazwaOpisDokumentu )
	EndIf

	If !nBitmap Then
		If bmpStamp Then
			// Bitmapa w miejscu pieczeci
			Ramka At nBmpCoord( 3 ), nBmpCoord( 4 ), BmpWidth, BmpHeight, 1
			Koniec
			PosX = nBmpCoord( 1 ) + nBmpCoord( 3 ) + SPACE_UNIT
		Else
			// Brak bitmapy i miejsce na pieczec
			RamkaTekst( 0, 0, ColWidth, RowHeight, 1, TRANSPARENT, StyleDescriptionC, "", StyleDescriptionC, INFO_PIECZEC_FIRMY )
			PosX = ColWidth + SPACE_UNIT
		EndIf
	EndIf

	DrukujBitmape()

	// Ustawiamy biezace wspolrzedne drukowania na koniec
	Print At 0, LastPosY + SPACE_UNIT;

EndSub

//----------------------------------------------------------------------------------------------------
// Drukowanie danych firmy ( wystawca / sprzedawca ) i kontrahenta ( adresat / nabywca )

Int Sub DrukujFirmeKontrahenta( Int DokumentOryginalny, String WystawcaSprzedawca, String AdresatNabywca, rDokumentSp Dokument, rKontrahent Firma )

	Int		ColWidth
	Int		TabColWidth( 4 ), TabColStyle( 4 )
	Long	TabColBackground( 4 )
	Int		deltaY, LastPosX, LastPosY
	Int		Table
	String	CompanyName, CompanyAddress, CompanyNIP

	// Wiersz z dwiema oddzielonymi kolumnami
	ColWidth = Str.Szer / 2
	// Czesc z opisem
	TabColWidth( 1 ) = TabColWidth( 3 ) = 0.15 * ColWidth
	TabColStyle( 1 ) = TabColStyle( 3 ) = StyleDescriptionL
	TabColBackground( 1 ) = TabColBackground( 3 ) = WHITE
	// Czesc z danymi
	TabColWidth( 2 ) = TabColWidth( 4 ) = 0.85 * ColWidth
	TabColStyle( 2 ) = TabColStyle( 4 ) = StyleDataL
	TabColBackground( 2 ) = TabColBackground( 4 ) = WHITE

	deltaY = GetStyleHeight( StyleDataL ) - GetStyleHeight( StyleDescriptionL )

	LastPosX = Str.Pozycja( #X )

	RamkaTekst( Str.Pozycja( #X ), Str.Pozycja( #Y ), ColWidth - SPACE_UNIT / 2, HEIGHT_HEAD, 1, BRIGHT, StyleHeadC, WystawcaSprzedawca, 0, "" )
	RamkaTekst( Str.Pozycja( #R ) + SPACE_UNIT , Str.Pozycja( #T ), ColWidth - SPACE_UNIT / 2, HEIGHT_HEAD, 1, BRIGHT, StyleHeadC, AdresatNabywca, 0, "" )

	LastPosY = Str.Pozycja( #Y )

	If !GRAFICZNY Then
		Print At LastPosX, LastPosY + SPACE_UNIT;
	EndIf

	// Nazwa i adres wystawcy ( sprzedawcy )
	CompanyName = IIF( DokumentOryginalny, NazwaFirmyDokumentKorygowany( Dokument, Firma ), NazwaFirmyDokumentPrawidlowy( Dokument, Firma ) )
	CompanyAddress = IIF( DokumentOryginalny, AdresFirmyDokumentKorygowany( Dokument, Firma ), AdresFirmyDokumentPrawidlowy( Dokument, Firma ) )
	CompanyNIP = IIF( DokumentOryginalny, NIPFirmyDokumentKorygowany( Dokument, Firma ), NIPFirmyDokumentPrawidlowy( Dokument, Firma ) )

	// Dane wystawcy ( sprzedawcy ) i adresata ( nabywcy )
	Table = Tabela 0, SPACE_UNIT, TabColWidth, TabColStyle, TabColBackground

	Tabela #Table
		Kolumna 1: Print At #X, #Y + deltaY; INFO_FIRMA
		Kolumna 2, CompanyName
		Kolumna 3: Print At #X, #Y + deltaY; INFO_FIRMA
		Kolumna 4, Dokument.danekh.KhNazwa
	Koniec
	Tabela #Table
		Kolumna 1: Print At #X, #Y + deltaY; INFO_ADRES
		Kolumna 2, CompanyAddress
		Kolumna 3: Print At #X, #Y + deltaY; INFO_ADRES
		Kolumna 4, Dokument.danekh.KhAdres + LF + Dokument.danekh.KhPoczta + " " + Dokument.danekh.KhMiasto + IIF( AMStrCMpi( FIRMA_KRAJ, Dokument.danekh.kraj.nazwa ), LF + Dokument.danekh.kraj.nazwa, "" )
	Koniec
	Tabela #Table
		Kolumna 1: Print At #X, #Y + deltaY; INFO_NIP
		Kolumna 2, CompanyNIP
		Kolumna 3: Print At #X, #Y + deltaY; INFO_NIP
		Kolumna 4, Dokument.danekh.KhNIP
	Koniec

	If GRAFICZNY Then
		RamkaTekst( LastPosX, LastPosY, ColWidth - SPACE_UNIT / 2, Str.Pozycja( #B ) - LastPosY, 1, TRANSPARENT, 0, "", 0, "" )
		RamkaTekst( LastPosX + ColWidth + SPACE_UNIT / 2, LastPosY, ColWidth - SPACE_UNIT / 2, Str.Pozycja( #B ) - LastPosY, 1, TRANSPARENT, 0, "", 0, "" )
	EndIf

	// Ustawiamy biezace wspolrzedne drukowania na koniec
	Print At 0, #Y + SPACE_UNIT;

EndSub

//----------------------------------------------------------------------------------------------------
Int Sub DrukujWystawceAdresata()

	DrukujFirmeKontrahenta( 0, INFO_WYSTAWCA, INFO_ADRESAT,  DokumentPrawidlowy, xFirmaPrawidlowy )

EndSub

//----------------------------------------------------------------------------------------------------
Int Sub DrukujSprzedaceNabywce()

	DrukujFirmeKontrahenta( 1, INFO_SPRZEDAWCA, INFO_NABYWCA, DokumentKorygowany, xFirmaKorygowany )

EndSub

//----------------------------------------------------------------------------------------------------
Int Sub DrukujTresc( String Tytul, String Tresc )
	
	Int		ColWidth
	Int		TabColWidth( 2 ), TabColStyle( 2 )
	Long	TabColBackground( 2 )
	Int		Table
	Int		deltaY
	String	TokenDescription, TokenData
	String	LastBuf
	Long	CurrPos

	ColWidth = Str.Szer
	RamkaTekst( Str.Pozycja( #X ), Str.Pozycja( #Y ), ColWidth, HEIGHT_HEAD, 1, BRIGHT, StyleHeadC, Tytul, 0, "" )
	Print At #X, #Y + SPACE_UNIT + 1;

	// Czesc z opisem
	TabColWidth( 1 ) = 0.2 * ColWidth
	TabColStyle( 1 ) = StyleDescriptionL
	TabColBackground( 1 ) = WHITE
	// Czesc z danymi
	TabColWidth( 2 ) = 0.8 * ColWidth
	TabColStyle( 2 ) = StyleDataL
	TabColBackground( 2 ) = WHITE

	deltaY = GetStyleHeight( StyleDataL ) - GetStyleHeight( StyleDescriptionL )

	Table = Tabela 0, SPACE_UNIT, TabColWidth, TabColStyle, TabColBackground

	// dwuznakowy NewLine dla pola MEdit ( 10 + 13 ) zamieniamy na LF dla raportu
	buf = Tresc
	While Replace NL, ( Using "%s", LF )
		Move 1
	Wend

	// Tresc korygowana / prawidlowa - jeden tekst zawierajacy objasnienia i dane
	// Parsowanie calego tekstu
	//		podzial na linie oddzielone LF
	//		parsowanie linii
	//			pierwszy dwukropek dzieli linie na objasnienie i dane
	//			przy braku dwukropka cala linia traktowana jako dane
	//			poczatkowe i koncowe biale znaki sa wycinane z objasnienia i danych
	// Cel parsowania :
	//		objasnienia wypisywane mniejsza czcionka aby nie zmniejszac czytelnosci
	While Len( buf )
		LastBuf = buf
		// Odczytanie kolejnej linii
		Move To 0
		If Find LF Then
			Delete To End
		EndIf
		// Podzial linii na objasnienie i dane
		Move To 0
		If Find DELIMITER Then
			CurrPos = Move 0
			TokenDescription = Mid( buf, 1, CurrPos - 1 )
			TokenData = Mid( buf, CurrPos + Len( DELIMITER ) )
		Else
			TokenDescription = ""
			TokenData = buf
		EndIf
		Tabela #Table
			Kolumna 1: Print At #X, #Y + deltaY; Trim( TokenDescription )
			Kolumna 2, Trim( TokenData )
		Koniec
		CurrPos = Len( buf )
		buf = LastBuf
		Move To 0
		// Usun z bufora wydrukowana linie
		Delete CurrPos + 1
	Wend
EndSub

//----------------------------------------------------------------------------------------------------
Int Sub DrukujDokumentKorygowany()

	Int			ColWidth
	Int			LastPosX
	String		dataSprzedazy
	String		dataWystawienia
	String		numer

	numer = GetListaKorektNumer( DokumentKorygowany, DokumentPrawidlowy )
	dataWystawienia = GetListaKorektDataWystawienia( DokumentKorygowany, DokumentPrawidlowy )
	dataSprzedazy = GetListaKorektDataSprzedazy( DokumentKorygowany, DokumentPrawidlowy )

	// Obramowanie tytulu sekcji wydruku
	RamkaTekst( Str.Pozycja( #X ), Str.Pozycja( #Y ), Str.Szer, HEIGHT_HEAD + 2 * SPACE_UNIT, 1, DARK, 0, "", 0, "" )
	// Tytul sekcji wydruku
	RamkaTekst( Str.Pozycja( #L ) + SPACE_UNIT, Str.Pozycja( #T ) + SPACE_UNIT, Str.Szer - 2 * SPACE_UNIT, HEIGHT_HEAD - 2 * SPACE_UNIT, IIF( GRAFICZNY, 1, 0 ), WHITE, StyleHeadC, INFO_DANEKORYGOWANE, 0, "" )
	Print At 0, #Y + 2 * SPACE_UNIT + 1;

	// Dane z dokumentu ( numer, data wystawienia, data sprzedazy ), ktorego dotyczy nota korygujaca
	LastPosX = Str.Pozycja( #X )
	ColWidth = Str.Szer / 3
	RamkaTekst( LastPosX, Str.Pozycja( #Y ), ColWidth, HEIGHT_HEAD, 1, BRIGHT, StyleHeadC, INFO_KORYGOWANY_NR, 0, "" )
	RamkaTekst( Str.Pozycja( #R ), Str.Pozycja( #T ), ColWidth, HEIGHT_HEAD, 1, BRIGHT, StyleHeadC, INFO_KORYGOWANY_DATA_WYST, 0, "" )
	RamkaTekst( Str.Pozycja( #R ), Str.Pozycja( #T ), ColWidth, HEIGHT_HEAD, 1, BRIGHT, StyleHeadC, INFO_KORYGOWANY_DATA_SPRZ, 0, "" )
	Print At LastPosX, #Y + 1;
	RamkaTekst( LastPosX, Str.Pozycja( #Y ), ColWidth, HEIGHT_DATA, 1, TRANSPARENT, StyleDataC, numer, 0, "" )
	RamkaTekst( Str.Pozycja( #R ), Str.Pozycja( #T ), ColWidth, HEIGHT_DATA, 1, TRANSPARENT, StyleDataC, dataWystawienia, 0, "" )
	RamkaTekst( Str.Pozycja( #R ), Str.Pozycja( #T ), ColWidth, HEIGHT_DATA, 1, TRANSPARENT, StyleDataC, dataSprzedazy, 0, "" )
	Print At LastPosX, #Y + SPACE_UNIT + 1;

	// Sprzedawca i nabywca
	DrukujSprzedaceNabywce()
	Print At LastPosX, #Y + 1;

	// Tresc korygowana / tresc prawidlowa
	DrukujTresc( INFO_TRESC_KORYGOWANA, sTrescKorygowana )
	Print At LastPosX, #Y + SPACE_UNIT + 1;
	DrukujTresc( INFO_TRESC_PRAWIDLOWA, sTrescPrawidlowa )
	Print At LastPosX, #Y + SPACE_UNIT + 1;

EndSub

//----------------------------------------------------------------------------------------------------
Int Sub DrukujOsobyUprawnione()

	Int		ColWidth
	Int		TabColWidth( 8 ), TabColStyle( 8 )
	Long	TabColBackground( 8 )
	Int		deltaY, TitleHeight
	Int		CurrentPosY
	Int		LastPage,LastPosX, LastPosY
	Int		Table

	// Wiersz z dwiema oddzielonymi kolumnami
	ColWidth = ( Str.Szer - SPACE_UNIT ) / 2

	// Czesc z opisem
	TabColWidth( 1 ) = TabColWidth( 5 ) = 0.20 * ColWidth
	TabColWidth( 3 ) = TabColWidth( 7 ) = 0.15 * ColWidth
	TabColStyle( 1 ) = TabColStyle( 3 ) = TabColStyle( 5 ) = TabColStyle( 7 ) = StyleDescriptionL
	TabColBackground( 1 ) = TabColBackground( 3 ) = TabColBackground( 5 ) = TabColBackground( 7 ) = WHITE
	// Czesc z danymi
	TabColWidth( 2 ) = TabColWidth( 6 ) = 0.45 * ColWidth
	TabColStyle( 2 ) = TabColStyle( 6 ) = StyleDataL
	TabColBackground( 2 ) = TabColBackground( 6 ) = WHITE
	// Miejsce na podpisy
	TabColWidth( 4 ) = TabColWidth( 8 ) = 0.2 * ColWidth
	TabColStyle( 4 ) = TabColStyle( 8 ) = StyleDataL
	TabColBackground( 4 ) = TabColBackground( 8 ) = WHITE

	Print At Str.Pozycja( #X ), Str.Pozycja( #Y ) + SPACE_UNIT;
	LastPage = Str.Numer
	LastPosX = Str.Pozycja( #X )
	LastPosY = Str.Pozycja( #Y )

	TitleHeight = IIF( GRAFICZNY, 1, 4.5 ) * HEIGHT_HEAD
	deltaY = TitleHeight + 2 * SPACE_UNIT

	// Dane i podpisy osob uprawnionych do wystawienia i odbioru noty korygujacej
	// Zaczynamy od danych zostawiajac miejsce na tytuly kolumn ( obsluzenie nowej strony )
	Table = Tabela 0, SPACE_UNIT, TabColWidth, TabColStyle, TabColBackground

	Tabela #Table
		Kolumna 1 : Print At 0, deltaY; INFO_IMIE + LF : Print At 0, #Y; INFO_NAZWISKO
		Kolumna 2 : Print At 0, deltaY; Arg4
		Kolumna 3 : Print At 0, deltaY; LF + INFO_PODPIS
		Kolumna 5 : Print At SPACE_UNIT, deltaY; INFO_IMIE + LF : Print At SPACE_UNIT, #Y; INFO_NAZWISKO
		Kolumna 6 : Print At SPACE_UNIT, deltaY; Arg5
		Kolumna 7 : Print At SPACE_UNIT, deltaY; LF : Print At SPACE_UNIT, #Y; INFO_PODPIS
	Koniec

	CurrentPosY = Str.Pozycja( #Y )

	If LastPage != Str.Numer Then
		LastPosX = 0
		LastPosY = 0
	EndIf

	RamkaTekst( LastPosX, LastPosY, ColWidth, TitleHeight, 1, BRIGHT, StyleHeadC, INFO_AKCEPTACJA_WYSTAWCY, 0, "" )
	RamkaTekst( Str.Pozycja( #R ) + SPACE_UNIT, Str.Pozycja( #T ), ColWidth, TitleHeight, 1, BRIGHT, StyleHeadC, INFO_AKCEPTACJA_ODBIORCY, 0, "" )

	// Ustawiamy biezace wspolrzedne drukowania na koniec
	Print At 0, CurrentPosY + SPACE_UNIT;

EndSub

//----------------------------------------------------------------------------------------------------
Int Sub DrukujUwagi()

	Int		LastPage,LastPosX, LastPosY
	Int		Table

	If Len( Arg6 ) Then
		LastPage = Str.Numer
		LastPosX = Str.Pozycja( #X )
		LastPosY = Str.Pozycja( #Y )

		// Zaczynamy od uwag zostawiajac miejsce na tytul "UWAGA"
		Table = Tabela 0, SPACE_UNIT, Str.Szer, StyleDataL

		Tabela #Table
			Kolumna 1 : Print At 0, HEIGHT_DATA + SPACE_UNIT; Arg6
		Koniec

		If LastPage != Str.Numer Then
			LastPosX = 0
			LastPosY = 0
		EndIf

		RamkaTekst( LastPosX, LastPosY, Str.Szer, HEIGHT_DATA, 1, BRIGHT, StyleDataC, INFO_UWAGA, 0, "" )
	EndIf

EndSub

//----------------------------------------------------------------------------------------------------
InicjujWydruk()
InicjujNaglowek()
InicjujStopke()	

DrukujNaglowekRaportu( TitleText, Arg9 )
DrukujWystawceAdresata()
DrukujDokumentKorygowany()
DrukujOsobyUprawnione()
DrukujUwagi()

Header( 1 )
Footer( 1 )